'-------------------------------------------------------------------
'
' GGSDBE.BAS
'
' Copyright (c) 1994 by Golden Gate Software
'
' Written by:
'    Richard D. Kligman
'    3825 Baker Street
'    San Diego, CA  92117-5706
'    (619) 483-8496
'    FAX: (619) 483-4651
'    CompuServe: 75300,2530
'
'-------------------------------------------------------------------

Option Explicit

'----------------------------------------------------------
'  Helper Structs
'----------------------------------------------------------

Type ggsConnection
   handle As Long       ' Most ggs functions require a handle
   errCode As Integer   ' Most ggs functions return an error code
   notifyMsg As Integer ' Some ggs functions don't have errors but rather notifications
   hCursor As Long      ' In case the user needs access to something outside the Helper
   sqlStmt As String    ' You almost always need to pass in the request as SQL
   dest As String * 256 ' Have a default place to put your field contents
End Type


'----------------------------------------------------------
'   DLL initialization functions
'----------------------------------------------------------
Declare Function initGGSBDE Lib "ggsbde.dll" (ByVal aliasDir As String) As Integer
Declare Function closeGGSBDE Lib "ggsbde.dll" () As Integer


'----------------------------------------------------------
'   Engine functions
'----------------------------------------------------------
Declare Function ggsDbiExecSQL Lib "ggsbde.dll" (ByVal sqlStmt As String, errCode As Integer, notifyMsg As Integer) As Long
Declare Sub ggsDbiFreeSQL Lib "ggsbde.dll" (ByVal classptr As Long)
Declare Function ggsDbiNextRecord Lib "ggsbde.dll" (ByVal classptr As Long, notifyMsg As Integer) As Integer
Declare Function ggsDbiGetField Lib "ggsbde.dll" (ByVal classptr As Long, ByVal fldNum As Integer, ByVal dest As String, ByVal nBytes As Integer) As Integer
Declare Function ggsGetDatabaseHandle Lib "ggsbde.dll" () As Long
Declare Function ggsGetCursor Lib "ggsbde.dll" (ByVal classptr As Long) As Long
Declare Sub ggsDbiGetNFields Lib "ggsbde.dll" (ByVal classptr As Long, fldNum As Integer)
Declare Function ggsDbiGetFieldName Lib "ggsbde.dll" (ByVal classptr As Long, ByVal fldNum As Integer, ByVal dest As String) As Integer

Sub execSQL (db As ggsConnection)

db.handle = ggsDbiExecSQL(db.sqlStmt, db.errCode, db.notifyMsg)
If db.errCode Then
   Err = db.errCode
   Error Err
End If

End Sub

Sub freeSQL (db As ggsConnection)

ggsDbiFreeSQL db.handle

End Sub

Sub getField (db As ggsConnection, ByVal fldNum%)

db.errCode = ggsDbiGetField(db.handle, fldNum, db.dest, Len(db.dest))
If db.errCode Then
   Err = db.errCode
   Error Err
End If

End Sub

Sub getFieldName (db As ggsConnection, ByVal fldNum%, dest As String)

db.errCode = ggsDbiGetFieldName(db.handle, fldNum, dest)
If db.errCode Then
   Err = db.errCode
   Error Err
End If

End Sub

Sub getNFields (db As ggsConnection, fldNum As Integer)

ggsDbiGetNFields db.handle, fldNum

End Sub

Sub nextRecord (db As ggsConnection)

db.errCode = ggsDbiNextRecord(db.handle, db.notifyMsg)
If db.errCode Then
   Err = db.errCode
   Error Err
End If

End Sub

